VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "comctl32.ocx"
Begin VB.UserControl ClassicView 
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   240
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
   Begin ComctlLib.ListView lvwProjects 
      Height          =   2010
      Left            =   -15
      TabIndex        =   0
      Top             =   -15
      Width           =   3510
      _ExtentX        =   6191
      _ExtentY        =   3545
      SortKey         =   1
      Arrange         =   2
      LabelEdit       =   1
      Sorted          =   -1  'True
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      OLEDragMode     =   1
      _Version        =   327682
      Icons           =   "imlLargeIcons"
      SmallIcons      =   "imlSmallIcons"
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   0
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Tahoma"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      OLEDragMode     =   1
      NumItems        =   4
      BeginProperty ColumnHeader(1) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "Title"
         Object.Width           =   3969
      EndProperty
      BeginProperty ColumnHeader(2) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         SubItemIndex    =   1
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "Type"
         Object.Width           =   3969
      EndProperty
      BeginProperty ColumnHeader(3) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         SubItemIndex    =   2
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "File"
         Object.Width           =   3969
      EndProperty
      BeginProperty ColumnHeader(4) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         SubItemIndex    =   3
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "Path"
         Object.Width           =   6615
      EndProperty
   End
   Begin ComctlLib.ImageList imlSmallIcons 
      Left            =   3570
      Top             =   75
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   16711935
      _Version        =   327682
      BeginProperty Images {0713E8C2-850A-101B-AFC0-4210102A8DA7} 
         NumListImages   =   2
         BeginProperty ListImage1 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "ClassicView.ctx":0000
            Key             =   ""
         EndProperty
         BeginProperty ListImage2 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "ClassicView.ctx":0112
            Key             =   ""
         EndProperty
      EndProperty
   End
   Begin ComctlLib.ImageList imlLargeIcons 
      Left            =   3570
      Top             =   645
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   32
      ImageHeight     =   32
      MaskColor       =   16711935
      _Version        =   327682
      BeginProperty Images {0713E8C2-850A-101B-AFC0-4210102A8DA7} 
         NumListImages   =   2
         BeginProperty ListImage1 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "ClassicView.ctx":0224
            Key             =   ""
         EndProperty
         BeginProperty ListImage2 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "ClassicView.ctx":04B6
            Key             =   ""
         EndProperty
      EndProperty
   End
End
Attribute VB_Name = "ClassicView"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "VB Recent Projects Classic View"
'*********************************************************************************************
'
' Shell Namespace sample
'
' Classic view control
'
'*********************************************************************************************
'
' Author: Eduardo A. Morcillo
' E-Mail: e_morcillo@yahoo.com
' Web Page: http://www.domaindlx.com/e_morcillo
'
' Distribution: You can freely use this code in your own applications but you
'               can't publish this code in a web site, online service, or any
'               other media, without my express permission.
'
' Usage: at your own risk.
'
' Tested with:
'              Windows Me/XP
'              VB6
'              IE 6
'
' Dependencies: OLELIB.TLB
'
' History:
'          12/29/2000 - The file was released
'
'*********************************************************************************************
Option Explicit

Implements olelib.IObjectSafety
Implements IView

Dim m_oShellView As frmShellView
Dim m_oShellFolder As IShellFolder
Dim m_oShellBrowser As IShellBrowser

' SHELLIDLIST clipboard format
Dim CF_SHELLIDLIST As Integer

Event SelectionChanged(Title As String, FileName As String, Path As String)
Sub OpenProject()

   m_oShellView.OnCommand CMDID_FILE_OPEN
   
End Sub


Private Sub pvReleasePIDLs()
Dim oItem As ListItem

   For Each oItem In lvwProjects.ListItems
   
      ' Release the item PIDL
      g_oMalloc.Free oItem.Tag
      
   Next

End Sub

Private Sub IObjectSafety_GetInterfaceSafetyOptions(riid As olelib.UUID, pdwSupportedOptions As olelib.OBJSAFE_Flags, pdwEnabledOptions As olelib.OBJSAFE_Flags)
   pdwSupportedOptions = INTERFACESAFE_FOR_UNTRUSTED_CALLER Or INTERFACESAFE_FOR_UNTRUSTED_DATA
   pdwEnabledOptions = pdwSupportedOptions
End Sub

Private Sub IObjectSafety_SetInterfaceSafetyOptions(riid As olelib.UUID, ByVal dwOptionSetMask As olelib.OBJSAFE_Flags, ByVal dwEnabledOptions As olelib.OBJSAFE_Flags)

End Sub


Private Sub IView_Refresh()
Dim oIShellFolder As IShellFolder
Dim oEnum As IEnumIDList
Dim lPIDL As Long
Dim sFile As String
Dim oItems As ListItems
Dim bIsProject As Boolean

   On Error Resume Next
   
   ' Get the IShellFolder interface
   Set oIShellFolder = m_oShellFolder
   
   ' Get the IEnumIDList interface
   ' from the folder object
   Set oEnum = oIShellFolder.EnumObjects(UserControl.hWnd, SHCONTF_FOLDERS Or SHCONTF_NONFOLDERS)
   
   ' Release the PIDLS
   pvReleasePIDLs
   
   ' Clear the listview
   lvwProjects.ListItems.Clear
    
   ' Get the ListItems colection
   Set oItems = lvwProjects.ListItems
   
   ' Enumerate all objects
   Do While oEnum.Next(1, lPIDL)
   
      ' Exit the loop if Next
      ' returns an error
      If Err.Number <> 0 Then Exit Do
      
      ' Get the file from the lPIDL
      sFile = GetPIDLName(lPIDL)
      bIsProject = IsProject(sFile)
            
      ' Add the project to the
      ' ListView
      With oItems.Add
      
         ' Save the PIDL
         .Tag = lPIDL
               
         ' Get project title
         .Text = GetProjectTitle(sFile)
         
         If bIsProject Then
            .SubItems(1) = "Project"
         Else
            .SubItems(1) = "Folder (Group)"
         End If
         
         ' Set file name
         .SubItems(2) = GetFilename(sFile)
         
         ' Set the project path
         .SubItems(3) = Left$(sFile, Len(sFile) - Len(.SubItems(1)) - 1)
         
         ' Set the icon
         If bIsProject Then
            .Icon = 1
            .SmallIcon = 1
         Else
            .Icon = 2
            .SmallIcon = 2
         End If
         
      End With
      
      ' Clear any error
      Err.Clear
      
   Loop
      
   Err.Clear
   
   lvwProjects.Arrange = lvwAutoTop

   ' Show the number of items in the status bar
   m_oShellBrowser.SetStatusTextSB CStr(lvwProjects.ListItems.Count) & " project(s)"
   
End Sub
Private Sub pvRemoveBorder()

   On Error Resume Next
   
   ' Remove the border
   SetWindowLong UserControl.hWnd, GWL_EXSTYLE, 0
   
   SetWindowPos UserControl.hWnd, 0, 0, 0, 0, 0, SWP_FRAMECHANGED Or SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOZORDER
      
End Sub

Private Function IView_SelectedFile() As String

   With lvwProjects.SelectedItem
      IView_SelectedFile = .SubItems(2) & "\" & .SubItems(1)
   End With
   
End Function

Private Property Get IView_View() As Long
   IView_View = lvwProjects.View
End Property

Private Sub lvwProjects_ItemClick(ByVal Item As ComctlLib.ListItem)

   RaiseEvent SelectionChanged(Item.Text, Item.SubItems(1), Item.SubItems(2))
   
End Sub

Private Sub lvwProjects_OLEStartDrag(Data As ComctlLib.DataObject, AllowedEffects As Long)
Dim oShellFolder As ShellFolder
Dim lFolderSize As Long
Dim lFolderPIDL As Long
Dim lItemSize As Long
Dim lItemPIDL As Long
Dim tCIDA As CIDA
Dim abShellIDList() As Byte

   On Error Resume Next

   AllowedEffects = DROPEFFECT_LINK Or DROPEFFECT_COPY

   ' Get the shell folder
   Set oShellFolder = m_oShellFolder
   
   ' Get the folder PIDL
   lFolderPIDL = oShellFolder.PIDL
   lFolderSize = GetPIDLSize(lFolderPIDL) + 2

   ' Get the item PIDL
   lItemPIDL = lvwProjects.SelectedItem.Tag
   lItemSize = GetPIDLSize(lItemPIDL) + 2
   
   ' Resize the array
   ReDim abShellIDList(0 To lFolderSize + lItemSize + 15)

   ' Set the tItem count and offsets
   tCIDA.cidl = 2                   ' Number of IDLISTs
                                    ' (0 = full Folder IDLIST, 1 = relative tItem IDLIST)
   tCIDA.OffsetPath = 12            ' Offset from beggining of the array
                                    ' to the folder IDLIST
   tCIDA.OffsetItem = 12 + lFolderSize    ' Offset from beggining of the array
                                    ' to the tItem ID

   ' Copy to the byte array
   MoveMemory abShellIDList(0), tCIDA, LenB(tCIDA)

   ' Copy the PIDLs
   MoveMemory abShellIDList(12), ByVal lFolderPIDL, lFolderSize
   MoveMemory abShellIDList(12 + lFolderSize), ByVal lItemPIDL, lItemSize
   
   ' Set the data
   Data.SetData abShellIDList(), CF_SHELLIDLIST
     
End Sub
Private Sub lvwProjects_DblClick()

   On Error Resume Next
   
   If Not lvwProjects.SelectedItem Is Nothing Then
   
      If GetPIDLAttributes(lvwProjects.SelectedItem.Tag) And SFGAO_FOLDER Then
      
         ' Browse the folder
         m_oShellBrowser.BrowseObject lvwProjects.SelectedItem.Tag, SBSP_DEFBROWSER Or SBSP_RELATIVE
         
      Else
   
         ' Open the project
         m_oShellView.OnCommand CMDID_FILE_OPEN
         
      End If
      
   End If
   
End Sub





Private Property Let IView_View(ByVal NewView As Long)
   lvwProjects.View = NewView
End Property


Private Sub IView_Initialize(ByVal Folder As olelib.IShellFolder, ByVal Browser As olelib.IShellBrowser, ByVal View As Object)
   
   Set m_oShellFolder = Folder
   Set m_oShellView = View
   Set m_oShellBrowser = Browser

End Sub
Private Sub IView_Destroy()
   
   Set m_oShellFolder = Nothing
   Set m_oShellView = Nothing
   Set m_oShellBrowser = Nothing

End Sub
Private Sub UserControl_Initialize()

   ' Register clipboard format
   CF_SHELLIDLIST = (RegisterClipboardFormat("Shell IDList Array") And &H7FFF&) Or &H8000

   ' Load icons in the imagelists
   ImageList_ReplaceIcon imlLargeIcons.hImageList, 0, LoadImage(App.hInstance, 2&, vbResIcon, 32, 32, 0)
   ImageList_ReplaceIcon imlLargeIcons.hImageList, 1, LoadImage(App.hInstance, 3&, vbResIcon, 32, 32, 0)
   ImageList_ReplaceIcon imlSmallIcons.hImageList, 0, LoadImage(App.hInstance, 2&, vbResIcon, 16, 16, 0)
   ImageList_ReplaceIcon imlSmallIcons.hImageList, 1, LoadImage(App.hInstance, 3&, vbResIcon, 16, 16, 0)
   
End Sub


Private Sub UserControl_Resize()
   
   lvwProjects.Move 0, 0, ScaleWidth, ScaleHeight
   lvwProjects.Arrange = lvwAutoTop
   lvwProjects.Refresh
   
End Sub


Private Sub UserControl_Show()
   
   If TypeName(UserControl.Parent) = "HTMLDocument" Then
      pvRemoveBorder
   End If

End Sub


