Attribute VB_Name = "mdlSubclass"
'*********************************************************************************************
'
' Shell Namespace sample
'
' frmShellView window procedure
'
'*********************************************************************************************
'
' Author: Eduardo A. Morcillo
' E-Mail: e_morcillo@yahoo.com
' Web Page: http://www.domaindlx.com/e_morcillo
'
' Distribution: You can freely use this code in your own applications but you
'               can't publish this code in a web site, online service, or any
'               other media, without my express permission.
'
' Usage: at your own risk.
'
' Tested with:
'              Windows Me/XP
'              VB6
'              IE 6
'
' Dependencies: OLELIB.TLB
'
' History:
'          04/03/2000 - The file was released
'
'*********************************************************************************************
Option Explicit

' Command IDs used on menus
Enum COMMANDIDs
   
   CMDID_FILE_OPEN = FCIDM_SHVIEWFIRST
   
   CMDID_VIEW_CHANGE
   CMDID_VIEW_WEB
   CMDID_VIEW_LARGEICONS
   CMDID_VIEW_SMALLICONS
   CMDID_VIEW_LIST
   CMDID_VIEW_DETAILS
   
   CMDID_TOOLS_VB
   
   CMDID_HELP_ABOUT
   
End Enum

Public Const PROPS_OLDPROC = "OldWinProc"
Public Const PROPS_SHELLVIEW = "ShellView"
Public Function ShellViewProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Dim lOldProc As Long
Dim frmSV As frmShellView
   
   On Error Resume Next
   
   ' Get a uncounted reference
   ' to the shell view
   MoveMemory frmSV, GetProp(hWnd, PROPS_SHELLVIEW), 4

   Select Case uMsg
   
      Case WM_COMMAND
      
         frmSV.OnCommand wParam
              
      Case WM_MENUSELECT
      
         frmSV.OnMenuHighlight LOWORD(wParam)
      
      Case WM_ACTIVATE, WM_SETFOCUS
         
         frmSV.OnActivate
                  
   End Select
   
   ' Release the refence
   MoveMemory frmSV, 0&, 4

   ' Get the original procedure pointer
   lOldProc = GetProp(hWnd, PROPS_OLDPROC)
   
   ' Call the original procedure
   ShellViewProc = CallWindowProc(lOldProc, hWnd, uMsg, wParam, lParam)
   
End Function
