VERSION 5.00
Object = "{EAB22AC0-30C1-11CF-A7EB-0000C05BAE0B}#1.1#0"; "shdocvw.dll"
Begin VB.UserControl WebView 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin SHDocVwCtl.WebBrowser WebBrowser1 
      Height          =   1410
      Left            =   60
      TabIndex        =   0
      Top             =   90
      Width           =   1575
      ExtentX         =   2778
      ExtentY         =   2487
      ViewMode        =   0
      Offline         =   0
      Silent          =   0
      RegisterAsBrowser=   0
      RegisterAsDropTarget=   1
      AutoArrange     =   0   'False
      NoClientEdge    =   0   'False
      AlignLeft       =   0   'False
      NoWebView       =   0   'False
      HideFileNames   =   0   'False
      SingleClick     =   0   'False
      SingleSelection =   0   'False
      NoFolders       =   0   'False
      Transparent     =   0   'False
      ViewID          =   "{0057D0E0-3573-11CF-AE69-08002B2E1262}"
      Location        =   ""
   End
   Begin VB.Menu mnuContext 
      Caption         =   "ContextMenu"
      Begin VB.Menu mnuRefresh 
         Caption         =   "&Refresh"
      End
   End
End
Attribute VB_Name = "WebView"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "WebView control"
'*********************************************************************************************
'
' Shell Namespace sample
'
' Web view control
'
'*********************************************************************************************
'
' Author: Eduardo A. Morcillo
' E-Mail: e_morcillo@yahoo.com
' Web Page: http://www.domaindlx.com/e_morcillo
'
' Distribution: You can freely use this code in your own applications but you
'               can't publish this code in a web site, online service, or any
'               other media, without my express permission.
'
' Usage: at your own risk.
'
' Tested with:
'              Windows Me/XP
'              VB6
'              IE 6
'
' Dependencies: OLELIB.TLB, IView.cls
'
' History:
'          12/29/2000 - The file was released
'
'*********************************************************************************************
Option Explicit

Implements IView

' Parent folder, browser and view
Dim m_oShellView As frmShellView
Dim m_oShellFolder As IShellFolder
Dim m_oShellBrowser As IShellBrowser

' ClassicView control
Dim WithEvents m_oView As ClassicView
Attribute m_oView.VB_VarHelpID = -1
Dim m_oClassicView As IView

' Properties
Dim m_lView As Long
Dim m_sSelectedFile As String

' HTML document
Dim WithEvents m_oDoc As HTMLDocument
Attribute m_oDoc.VB_VarHelpID = -1

'
' GetClassicView
'
' Finds the classic view control in the page
'
Private Sub GetClassicView()
Dim oElems As IHTMLElementCollection
Dim lIdx As Long

   On Error Resume Next
   
   ' Find the OBJECT tags
   Set oElems = WebBrowser1.Document.All.tags("OBJECT")

   If oElems.Length > 0 Then
   
      For lIdx = 0 To oElems.Length - 1
         
         If TypeOf oElems(lIdx).object Is ClassicView Then
            
            ' Get the classic view control
            Set m_oView = oElems(lIdx).object
            Set m_oClassicView = m_oView
               
            ' Initialize the classic view
            m_oClassicView.Initialize m_oShellFolder, m_oShellBrowser, m_oShellView
            m_oClassicView.View = m_lView
            
            ' Refresh the classic view
            m_oClassicView.Refresh
            
         End If
         
      Next
      
   End If

End Sub

Private Sub IView_Destroy()
   
   ' Release all the objects
   
   Set m_oShellFolder = Nothing
   Set m_oShellView = Nothing
   Set m_oShellBrowser = Nothing

   Set m_oDoc = Nothing
   
   Set m_oClassicView = Nothing
   Set m_oView = Nothing
   
End Sub

Private Sub IView_Initialize(ByVal Folder As olelib.IShellFolder, ByVal Browser As olelib.IShellBrowser, ByVal View As Object)
      
   Set m_oShellFolder = Folder
   Set m_oShellView = View
   Set m_oShellBrowser = Browser

End Sub

Private Sub IView_Refresh()
      
   On Error Resume Next
   
   ' Navigate to the vbproj.htt page
   WebBrowser1.Navigate "res://" & App.Path & "\" & App.EXEName & ".dll/vbproj.htt", 14
            
End Sub

Private Function IView_SelectedFile() As String

   IView_SelectedFile = m_sSelectedFile
   
End Function

Private Property Get IView_View() As Long
   
   IView_View = m_lView
   
End Property

Private Property Let IView_View(ByVal NewView As Long)

   On Error Resume Next
   
   m_lView = NewView
   If Not m_oClassicView Is Nothing Then
      m_oClassicView.View = NewView
   End If
   
End Property

Private Function m_oDoc_oncontextmenu() As Boolean

   ' Show the popup menu
   PopupMenu mnuContext
   
   ' Remove the context menu
   m_oDoc_oncontextmenu = False
   
End Function

Private Function m_oDoc_ondragstart() As Boolean
'
End Function

Private Function m_oDoc_onselectstart() As Boolean
'
End Function


Private Sub m_oView_SelectionChanged(Title As String, FileName As String, Path As String)

   m_sSelectedFile = Path & "\" & FileName
   
End Sub

Private Sub mnuRefresh_Click()

   ' Refresh the view
   IView_Refresh
   
End Sub

Private Sub UserControl_Hide()

   WebBrowser1.Navigate "about:blank"
   
End Sub

Private Sub UserControl_Resize()

   WebBrowser1.Move 0, 0, ScaleWidth, ScaleHeight
   
End Sub



Private Sub WebBrowser1_DocumentComplete(ByVal pDisp As Object, URL As Variant)
   
   ' Get the document
   Set m_oDoc = WebBrowser1.Document
   
   ' Get the classic view control
   GetClassicView
 
End Sub

